/* filters.c generated by valac 0.12.1, the Vala compiler
 * generated from filters.vala, do not modify */

/* Emperor - an orthodox file manager for the GNOME desktop
 * Copyright (C) 2011    Thomas Jollans
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <emperor.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkkeysyms.h>
#include <gdk/gdk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Block1Data {
	int _ref_count_;
	EmperorApplicationEmperorCore* app;
	GtkToggleAction* hidden_action;
	GtkToggleAction* backup_action;
};



gboolean emperor_modules_filter_hidden (GFile* f, GFileInfo* fi, gboolean currently_visible);
gboolean emperor_modules_filter_backup (GFile* f, GFileInfo* fi, gboolean currently_visible);
void emperor_modules_toggle_filter (EmperorApplicationMainWindow* main_window, const gchar* filter, EmperorApplicationFilePaneFileFilterFunc func, void* func_target, gboolean* use_filter);
void load_module (EmperorApplicationModuleRegistry* reg);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
static void _lambda0_ (Block1Data* _data1_);
static gboolean _emperor_modules_filter_hidden_emperor_application_file_pane_file_filter_func (GFile* f, GFileInfo* fi, gboolean currently_visible, gpointer self);
static void __lambda0__gtk_toggle_action_toggled (GtkToggleAction* _sender, gpointer self);
static void _lambda1_ (Block1Data* _data1_);
static gboolean _emperor_modules_filter_backup_emperor_application_file_pane_file_filter_func (GFile* f, GFileInfo* fi, gboolean currently_visible, gpointer self);
static void __lambda1__gtk_toggle_action_toggled (GtkToggleAction* _sender, gpointer self);
static void _lambda2_ (EmperorApplicationMainWindow* main_window, Block1Data* _data1_);
static void __lambda2__emperor_application_user_interface_manager_main_window_ready (EmperorApplicationUserInterfaceManager* _sender, EmperorApplicationMainWindow* main_window, gpointer self);


gboolean emperor_modules_filter_hidden (GFile* f, GFileInfo* fi, gboolean currently_visible) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (f != NULL, FALSE);
	g_return_val_if_fail (fi != NULL, FALSE);
	if (currently_visible) {
		gboolean _tmp1_;
		_tmp1_ = g_file_info_get_is_hidden (fi);
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean emperor_modules_filter_backup (GFile* f, GFileInfo* fi, gboolean currently_visible) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (f != NULL, FALSE);
	g_return_val_if_fail (fi != NULL, FALSE);
	if (currently_visible) {
		gboolean _tmp1_;
		_tmp1_ = g_file_info_get_is_backup (fi);
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void emperor_modules_toggle_filter (EmperorApplicationMainWindow* main_window, const gchar* filter, EmperorApplicationFilePaneFileFilterFunc func, void* func_target, gboolean* use_filter) {
	gboolean flag = FALSE;
	GtkApplication* _tmp6_ = NULL;
	EmperorApplicationPrefsMachine* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_if_fail (main_window != NULL);
	g_return_if_fail (filter != NULL);
	if (use_filter != NULL) {
		flag = *use_filter;
	} else {
		EmperorApplicationFilePane* _tmp0_ = NULL;
		gboolean _tmp1_;
		_tmp0_ = emperor_application_main_window_get_left_pane (main_window);
		_tmp1_ = emperor_application_file_pane_using_filter (_tmp0_, filter);
		flag = !_tmp1_;
	}
	if (flag) {
		EmperorApplicationFilePane* _tmp2_ = NULL;
		EmperorApplicationFilePane* _tmp3_ = NULL;
		_tmp2_ = emperor_application_main_window_get_left_pane (main_window);
		emperor_application_file_pane_add_filter (_tmp2_, filter, func, func_target);
		_tmp3_ = emperor_application_main_window_get_right_pane (main_window);
		emperor_application_file_pane_add_filter (_tmp3_, filter, func, func_target);
	} else {
		EmperorApplicationFilePane* _tmp4_ = NULL;
		EmperorApplicationFilePane* _tmp5_ = NULL;
		_tmp4_ = emperor_application_main_window_get_left_pane (main_window);
		emperor_application_file_pane_remove_filter (_tmp4_, filter);
		_tmp5_ = emperor_application_main_window_get_right_pane (main_window);
		emperor_application_file_pane_remove_filter (_tmp5_, filter);
	}
	_tmp6_ = gtk_window_get_application ((GtkWindow*) main_window);
	_tmp7_ = emperor_application_emperor_core_get_prefs (EMPEROR_APPLICATION_EMPEROR_CORE (_tmp6_));
	_tmp8_ = g_strconcat ("use-filter:", filter, NULL);
	_tmp9_ = _tmp8_;
	emperor_application_prefs_machine_set_boolean (_tmp7_, _tmp9_, flag);
	_g_free0 (_tmp9_);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->backup_action);
		_g_object_unref0 (_data1_->hidden_action);
		_g_object_unref0 (_data1_->app);
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean _emperor_modules_filter_hidden_emperor_application_file_pane_file_filter_func (GFile* f, GFileInfo* fi, gboolean currently_visible, gpointer self) {
	gboolean result;
	result = emperor_modules_filter_hidden (f, fi, currently_visible);
	return result;
}


static void _lambda0_ (Block1Data* _data1_) {
	EmperorApplicationMainWindow* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = emperor_application_emperor_core_get_main_window (_data1_->app);
	_tmp1_ = gtk_toggle_action_get_active (_data1_->hidden_action);
	_tmp2_ = !_tmp1_;
	emperor_modules_toggle_filter (_tmp0_, "filters/hidden", _emperor_modules_filter_hidden_emperor_application_file_pane_file_filter_func, NULL, &_tmp2_);
}


static void __lambda0__gtk_toggle_action_toggled (GtkToggleAction* _sender, gpointer self) {
	_lambda0_ (self);
}


static gboolean _emperor_modules_filter_backup_emperor_application_file_pane_file_filter_func (GFile* f, GFileInfo* fi, gboolean currently_visible, gpointer self) {
	gboolean result;
	result = emperor_modules_filter_backup (f, fi, currently_visible);
	return result;
}


static void _lambda1_ (Block1Data* _data1_) {
	EmperorApplicationMainWindow* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = emperor_application_emperor_core_get_main_window (_data1_->app);
	_tmp1_ = gtk_toggle_action_get_active (_data1_->backup_action);
	_tmp2_ = !_tmp1_;
	emperor_modules_toggle_filter (_tmp0_, "filters/backup", _emperor_modules_filter_backup_emperor_application_file_pane_file_filter_func, NULL, &_tmp2_);
}


static void __lambda1__gtk_toggle_action_toggled (GtkToggleAction* _sender, gpointer self) {
	_lambda1_ (self);
}


static void _lambda2_ (EmperorApplicationMainWindow* main_window, Block1Data* _data1_) {
	EmperorApplicationFilePane* _tmp0_ = NULL;
	EmperorApplicationFilePane* _tmp1_ = NULL;
	EmperorApplicationFilePane* _tmp2_ = NULL;
	EmperorApplicationFilePane* _tmp3_ = NULL;
	EmperorApplicationPrefsMachine* _tmp4_ = NULL;
	gboolean _tmp5_;
	gboolean hide_hidden;
	EmperorApplicationPrefsMachine* _tmp6_ = NULL;
	gboolean _tmp7_;
	gboolean hide_backup;
	g_return_if_fail (main_window != NULL);
	_tmp0_ = emperor_application_main_window_get_left_pane (main_window);
	emperor_application_file_pane_add_query_attribute (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN);
	_tmp1_ = emperor_application_main_window_get_left_pane (main_window);
	emperor_application_file_pane_add_query_attribute (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP);
	_tmp2_ = emperor_application_main_window_get_right_pane (main_window);
	emperor_application_file_pane_add_query_attribute (_tmp2_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN);
	_tmp3_ = emperor_application_main_window_get_right_pane (main_window);
	emperor_application_file_pane_add_query_attribute (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP);
	_tmp4_ = emperor_application_emperor_core_get_prefs (_data1_->app);
	_tmp5_ = emperor_application_prefs_machine_get_boolean (_tmp4_, "use-filter:filters/hidden", TRUE);
	hide_hidden = _tmp5_;
	_tmp6_ = emperor_application_emperor_core_get_prefs (_data1_->app);
	_tmp7_ = emperor_application_prefs_machine_get_boolean (_tmp6_, "use-filter:filters/backup", TRUE);
	hide_backup = _tmp7_;
	emperor_modules_toggle_filter (main_window, "filters/hidden", _emperor_modules_filter_hidden_emperor_application_file_pane_file_filter_func, NULL, &hide_hidden);
	gtk_toggle_action_set_active (_data1_->hidden_action, !hide_hidden);
	emperor_modules_toggle_filter (main_window, "filters/backup", _emperor_modules_filter_backup_emperor_application_file_pane_file_filter_func, NULL, &hide_backup);
	gtk_toggle_action_set_active (_data1_->backup_action, !hide_backup);
}


static void __lambda2__emperor_application_user_interface_manager_main_window_ready (EmperorApplicationUserInterfaceManager* _sender, EmperorApplicationMainWindow* main_window, gpointer self) {
	_lambda2_ (main_window, self);
}


void load_module (EmperorApplicationModuleRegistry* reg) {
	Block1Data* _data1_;
	EmperorApplicationEmperorCore* _tmp0_ = NULL;
	EmperorApplicationEmperorCore* _tmp1_;
	EmperorApplicationUserInterfaceManager* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkMenu* _tmp4_ = NULL;
	GtkMenu* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GtkToggleAction* _tmp7_ = NULL;
	EmperorApplicationUserInterfaceManager* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GtkToggleAction* _tmp11_ = NULL;
	EmperorApplicationUserInterfaceManager* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	EmperorApplicationUserInterfaceManager* _tmp14_ = NULL;
	g_return_if_fail (reg != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = emperor_application_module_registry_get_application (reg);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_data1_->app = _tmp1_;
	_tmp2_ = emperor_application_emperor_core_get_ui_manager (_data1_->app);
	_tmp3_ = _ ("_View");
	_tmp4_ = emperor_application_user_interface_manager_get_menu (_tmp2_, _tmp3_, 2);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp5_);
	_tmp6_ = _ ("Show Hidden Files");
	_tmp7_ = gtk_toggle_action_new ("filters/toggle:hidden", _tmp6_, NULL, NULL);
	_data1_->hidden_action = _tmp7_;
	emperor_application_module_registry_register_action (reg, (GtkAction*) _data1_->hidden_action);
	gtk_action_set_accel_path ((GtkAction*) _data1_->hidden_action, "<Emperor-Main>/Filters/Toggle_Hidden");
	gtk_accel_map_add_entry ("<Emperor-Main>/Filters/Toggle_Hidden", GDK_KEY_H, GDK_CONTROL_MASK);
	g_signal_connect_data (_data1_->hidden_action, "toggled", (GCallback) __lambda0__gtk_toggle_action_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	gtk_action_connect_accelerator ((GtkAction*) _data1_->hidden_action);
	_tmp8_ = emperor_application_emperor_core_get_ui_manager (_data1_->app);
	_tmp9_ = _ ("_View");
	emperor_application_user_interface_manager_add_action_to_menu (_tmp8_, _tmp9_, (GtkAction*) _data1_->hidden_action, -1);
	_tmp10_ = _ ("Show Backup Files");
	_tmp11_ = gtk_toggle_action_new ("filters/toggle:backup", _tmp10_, NULL, NULL);
	_data1_->backup_action = _tmp11_;
	emperor_application_module_registry_register_action (reg, (GtkAction*) _data1_->backup_action);
	g_signal_connect_data (_data1_->backup_action, "toggled", (GCallback) __lambda1__gtk_toggle_action_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp12_ = emperor_application_emperor_core_get_ui_manager (_data1_->app);
	_tmp13_ = _ ("_View");
	emperor_application_user_interface_manager_add_action_to_menu (_tmp12_, _tmp13_, (GtkAction*) _data1_->backup_action, -1);
	_tmp14_ = emperor_application_emperor_core_get_ui_manager (_data1_->app);
	g_signal_connect_data (_tmp14_, "main-window-ready", (GCallback) __lambda2__emperor_application_user_interface_manager_main_window_ready, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}



